/***************************************************************************************************
Module: DrvCtl.h
***************************************************************************************************/


#pragma once


////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef DRV_CTL_H
#define DRV_CTL_H


////////////////////////////////////////////////////////////////////////////////////////////////////


#define DbgOut(fmt, ...)					\
	OutputDebugStringF("[%s] (%s) "##fmt,	\
	__FILE__, __FUNCTION__, __VA_ARGS__)

inline void OutputDebugStringF(PCSTR szFormat, ...)
{
	va_list ArgList;
	char szBuffer[1024];

	va_start(ArgList, szFormat);
	_vsnprintf_s(szBuffer, _countof(szBuffer), _TRUNCATE, szFormat, ArgList);
	va_end(ArgList);

	OutputDebugStringA(szBuffer);
}


////////////////////////////////////////////////////////////////////////////////////////////////////


BOOL DrvCtl_Install(PCTSTR szServiceName, PCTSTR szDriverPath);
BOOL DrvCtl_Uninstall(PCTSTR szServiceName);
BOOL DrvCtl_Start(PCTSTR szServiceName);
BOOL DrvCtl_Stop(PCTSTR szServiceName);
BOOL DrvCtl_Control(PCTSTR szSymbolicLink, DWORD ioControlCode,
	PVOID pInBuffer, DWORD inBufferSize, PVOID pOutBuffer, DWORD outBufferSize);


////////////////////////////////////////////////////////////////////////////////////////////////////


#endif


//////////////////////////////////////////// End Of File ///////////////////////////////////////////