/***************************************************************************************************
Module: HandleViewerUser.cpp
***************************************************************************************************/


#include <Windows.h>
#include <tchar.h>
#include <locale.h>
#include <stdio.h>
#include "DrvCtl.h"
#include "HandleViewerUser.h"


////////////////////////////////////////////////////////////////////////////////////////////////////


void GetDriverPath(LPTSTR szDriverPath)
{
	GetModuleFileName(NULL, szDriverPath, MAX_PATH);
	for (size_t i = _tcslen(szDriverPath); i >= 0; i--)
	{
		if (szDriverPath[i] == '\\')
		{
			szDriverPath[i + 1] = '\0';
			_tcscat_s(szDriverPath, MAX_PATH, DRIVER_NAME);

			break;
		}
	}
}


////////////////////////////////////////////////////////////////////////////////////////////////////


int MainLoop()
{
	DWORD ProcessId = 0;
	OBJECT_INFO ObjectInfo[5000];
	
	while (TRUE)
	{
		RtlZeroMemory(ObjectInfo, sizeof(ObjectInfo));

		_tsystem(TEXT("pause"));
		_tsystem(TEXT("cls"));
		_tprintf(TEXT("Enter Process Id : "));
		_tscanf_s(TEXT("%d"), &ProcessId);

		if (ProcessId == 88888888)
		{
			DrvCtl_Stop(SERVICE_NAME);
			DrvCtl_Uninstall(SERVICE_NAME);
			return 0;
		}

		if (!DrvCtl_Control(SYMBOLIC_LINK, IOCTL_VIEW_HANDLE,
			&ProcessId, sizeof(DWORD), ObjectInfo, sizeof(ObjectInfo)))
		{
			_tprintf(TEXT("Failed!\n"));
			continue;
		}

		for (int i = 0; ObjectInfo[i].Address != NULL; i++)
		{
			_tprintf(sizeof(TCHAR) == 1
				? TEXT("0x%08llX     0x%08X    0x%016llX    %S\n")
				: TEXT("0x%08llX     0x%08X    0x%016llX    %s\n"),
				(ULONG_PTR)ObjectInfo[i].Handle, ObjectInfo[i].AccessMask,
				(ULONG_PTR)ObjectInfo[i].Address, ObjectInfo[i].szTypeName);
		}
	}

	return 0;
}


////////////////////////////////////////////////////////////////////////////////////////////////////


int _tmain(int argc, TCHAR *argv[])
{
	_tsetlocale(LC_ALL, TEXT(""));

	TCHAR szDriverPath[MAX_PATH];
	GetDriverPath(szDriverPath);

	DrvCtl_Install(SERVICE_NAME, szDriverPath);
	if (!DrvCtl_Start(SERVICE_NAME))
	{
		_tprintf(TEXT("Install driver failed!\n"));
		Sleep(3000);
		return 0;
	}

	return MainLoop();
}


//////////////////////////////////////////// End Of File ///////////////////////////////////////////