/***************************************************************************************************
Module: CenterWindow.c
Author: ZChameleon @ 2016
***************************************************************************************************/


#include <Windows.h>
#include "CenterWindow.h"


////////////////////////////////////////////////////////////////////////////////////////////////////


BOOL CenterWindow(HWND hwnd)
{
	APPBARDATA bar_data;
	memset(&bar_data, 0, sizeof(bar_data));
	bar_data.cbSize = sizeof(bar_data);
	bar_data.hWnd = FindWindow(TEXT("Shell_TrayWnd"), NULL);
	SHAppBarMessage(ABM_GETTASKBARPOS, &bar_data);

	BOOL is_bar_auto_hide = FALSE;
	HWND hwndBar = (HWND)SHAppBarMessage(ABM_GETAUTOHIDEBAR, &bar_data);
	if (hwndBar != NULL)
	{
		is_bar_auto_hide = TRUE;
	}

	RECT rect;
	GetWindowRect(hwnd, &rect);
	int screen_width = GetSystemMetrics(SM_CXSCREEN);
	int screen_height = GetSystemMetrics(SM_CYSCREEN);
	int new_left = 0;
	int new_top = 0;
	switch (bar_data.uEdge)
	{
		case 0:
		{
			new_left = is_bar_auto_hide
				? (screen_width - (rect.right - rect.left)) / 2
				: (screen_width - (rect.right - rect.left) + bar_data.rc.right) / 2;
			new_top = (screen_height - (rect.bottom - rect.top)) / 2;
			break;
		}

		case 1:
		{
			new_left = (screen_width - (rect.right - rect.left)) / 2;
			new_top = is_bar_auto_hide
				? (screen_height - (rect.bottom - rect.top)) / 2
				: (screen_height - (rect.bottom - rect.top) + bar_data.rc.bottom) / 2;
			break;
		}

		case 2:
		{
			new_left = is_bar_auto_hide
				? (screen_width - (rect.right - rect.left)) / 2
				: (screen_width - (rect.right - rect.left) - (bar_data.rc.right - bar_data.rc.left)) / 2;
			new_top = (screen_height - (rect.bottom - rect.top)) / 2;
			break;
		}

		case 3:
		{
			new_left = (screen_width - (rect.right - rect.left)) / 2;
			new_top = is_bar_auto_hide
				? (screen_height - (rect.bottom - rect.top)) / 2
				: (screen_height - (rect.bottom - rect.top) - (bar_data.rc.bottom - bar_data.rc.top) / 2) / 2;
			break;
		}

		default:
			break;
	}

	SetWindowPos(hwnd, NULL, new_left, new_top, 0, 0, SWP_NOZORDER | SWP_NOSIZE);

	return TRUE;
}


//////////////////////////////////////////// End Of File ///////////////////////////////////////////