/***************************************************************************************************
Module: DriverControl.h
Author: ZChameleon @ 2015
***************************************************************************************************/


#pragma once


////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef DRIVER_CONTROL_H
#define DRIVER_CONTROL_H


////////////////////////////////////////////////////////////////////////////////////////////////////


#include <stdio.h>


////////////////////////////////////////////////////////////////////////////////////////////////////


#define DbgOut(fmt, ...)					\
	OutputDebugStringF("[%s] (%s) "##fmt,	\
	__FILE__, __FUNCTION__, __VA_ARGS__)

inline void OutputDebugStringF(PCSTR szFormat, ...)
{
	va_list ArgList;
	char szBuffer[1024];

	va_start(ArgList, szFormat);
	_vsnprintf_s(szBuffer, _countof(szBuffer), _TRUNCATE, szFormat, ArgList);
	va_end(ArgList);

	OutputDebugStringA(szBuffer);
}


////////////////////////////////////////////////////////////////////////////////////////////////////


BOOL DrvCtl_Install(PCTSTR szServiceName, PCTSTR szDriverPath);
BOOL DrvCtl_Uninstall(PCTSTR szServiceName);
BOOL DrvCtl_Start(PCTSTR szServiceName);
BOOL DrvCtl_Stop(PCTSTR szServiceName);
BOOL DrvCtl_Control(PCTSTR szSymbolicLink, DWORD IoControlCode,
	PVOID InBuffer, DWORD InBufferSize, PVOID OutBuffer, DWORD OutBufferSize);


////////////////////////////////////////////////////////////////////////////////////////////////////


#endif


//////////////////////////////////////////// End Of File ///////////////////////////////////////////