/***************************************************************************************************
Module: Main.c
Author: ZChameleon @ 2016
***************************************************************************************************/


#include <Windows.h>
#include <windowsx.h>
#include <tchar.h>
#include "resource.h"
#include "RestoreAccess.h"
#include "CenterWindow.h"


////////////////////////////////////////////////////////////////////////////////////////////////////


#if defined _M_IX86
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' \
version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_X64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' \
version='6.0.0.0' processorArchitecture='amd64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#endif


////////////////////////////////////////////////////////////////////////////////////////////////////


#define HANDLE_DLGMSG(hwnd, message, func)					\
	case (message): return (SetDlgMsgResult(hwnd, Msg,		\
		HANDLE_##message((hwnd), (wParam), (lParam), (func))))


////////////////////////////////////////////////////////////////////////////////////////////////////


BOOL g_Author;


////////////////////////////////////////////////////////////////////////////////////////////////////


BOOL MainDlg_OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	SetWindowPos(hWnd, NULL, 0, 0, 162, 159, SWP_NOZORDER | SWP_NOMOVE);
	CenterWindow(hWnd);

	if (!DriverInstall())
	{
		MessageBox(hWnd, TEXT("Install driver failed!"), TEXT("Restore"), MB_OK);
	}

	return TRUE;
}


////////////////////////////////////////////////////////////////////////////////////////////////////


void MainDlg_OnCommand(HWND hWnd, int Id, HWND hWndCtl, UINT CodeNotify)
{
	switch (Id)
	{
		case IDC_BTN_AUTHOR:
		{
			for (int i = g_Author ? 213 : 159; g_Author ? i >= 159 : i <= 213; g_Author ? i-- : i++)
			{
				SetWindowPos(hWnd, NULL, 0, 0, 162, i, SWP_NOZORDER | SWP_NOMOVE);
				UpdateWindow(hWnd);
				Sleep(1);
			}
			EnableWindow(GetDlgItem(hWnd, IDC_BTN_RESTORE), TRUE);
			g_Author = ~g_Author;
			break;
		}

		case IDC_BTN_RESTORE:
		{
			TCHAR szActiveId[10];
			TCHAR szPassiveId[10];

			RtlZeroMemory(szActiveId, sizeof(szActiveId));
			RtlZeroMemory(szPassiveId, sizeof(szPassiveId));

			GetDlgItemText(hWnd, IDC_EDT_ACT, szActiveId, sizeof(szActiveId) / sizeof(TCHAR));
			GetDlgItemText(hWnd, IDC_EDT_PAS, szPassiveId, sizeof(szActiveId) / sizeof(TCHAR));

			if (!RestoreAccess(_ttoi(szActiveId), _ttoi(szPassiveId)))
			{
				MessageBox(hWnd, TEXT("Restore failed!"), TEXT("Restore"), MB_OK);
			}

			break;
		}
	}
}


////////////////////////////////////////////////////////////////////////////////////////////////////


void MainDlg_OnClose(HWND hWnd)
{
	DriverUninstall();
	EndDialog(hWnd, 0);
}


////////////////////////////////////////////////////////////////////////////////////////////////////


INT_PTR CALLBACK MainDlg_Proc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch (Msg)
	{
		HANDLE_DLGMSG(hWnd, WM_INITDIALOG, MainDlg_OnInitDialog);
		HANDLE_DLGMSG(hWnd, WM_COMMAND, MainDlg_OnCommand);
		HANDLE_DLGMSG(hWnd, WM_CLOSE, MainDlg_OnClose);
	}

	return FALSE;
}


////////////////////////////////////////////////////////////////////////////////////////////////////


int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR CmdLine, int CmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DLG_MAIN), NULL, MainDlg_Proc);

	return 0;
}


//////////////////////////////////////////// End Of File ///////////////////////////////////////////