/***************************************************************************************************
Module: RestoreAccess.c
Author: ZChameleon @ 2016
***************************************************************************************************/


#include <Windows.h>
#include <tchar.h>
#include "DriverControl.h"
#include "RestoreAccess.h"


////////////////////////////////////////////////////////////////////////////////////////////////////


void GetDriverPath(LPTSTR szDriverPath)
{
	GetModuleFileName(NULL, szDriverPath, MAX_PATH);
	for (size_t i = _tcslen(szDriverPath); i >= 0; i--)
	{
		if (szDriverPath[i] == '\\')
		{
			szDriverPath[i + 1] = '\0';
			_tcscat_s(szDriverPath, MAX_PATH, DRIVER_NAME);

			break;
		}
	}
}


////////////////////////////////////////////////////////////////////////////////////////////////////


BOOL DriverInstall()
{
	TCHAR szDriverPath[MAX_PATH];

	RtlZeroMemory(szDriverPath, sizeof(szDriverPath));
	GetDriverPath(szDriverPath);

	DrvCtl_Install(SERVICE_NAME, szDriverPath);
	if (!DrvCtl_Start(SERVICE_NAME))
	{
		return FALSE;
	}

	return TRUE;
}


////////////////////////////////////////////////////////////////////////////////////////////////////


void DriverUninstall()
{
	DrvCtl_Stop(SERVICE_NAME);
	DrvCtl_Uninstall(SERVICE_NAME);
}


////////////////////////////////////////////////////////////////////////////////////////////////////


BOOL RestoreAccess(DWORD ActiveId, DWORD PassiveId)
{
	ULONG64 ProcessId = 0;

	ProcessId = MAKELONG64(PassiveId, ActiveId);
	if (!DrvCtl_Control(SYMBOLIC_LINK, IOCTL_RESTORE_ACCESS,
		&ProcessId, sizeof(ActiveId) + sizeof(PassiveId), NULL, 0))
	{
		return FALSE;
	}

	return TRUE;
}


//////////////////////////////////////////// End Of File ///////////////////////////////////////////